[BACK]Return to mktemp.1 CVS log [TXT][DIR] Up to [local] / src / usr.bin / mktemp

File: [local] / src / usr.bin / mktemp / mktemp.1 (download)

Revision 1.12, Thu Aug 5 09:19:35 1999 UTC (24 years, 10 months ago) by millert
Branch: MAIN
CVS Tags: OPENBSD_2_6_BASE, OPENBSD_2_6
Changes since 1.11: +18 -5 lines

o Use 10 X's in examples (noted by Theo)
o Add another example using the pretty brace block form

.\"	$OpenBSD: mktemp.1,v 1.12 1999/08/05 09:19:35 millert Exp $
.\"
.\" Copyright (c) 1989, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.Dd November 20, 1996
.Dt MKTEMP 1
.Os
.Sh NAME
.Nm mktemp
.Nd make temporary file name (unique)
.Sh SYNOPSIS
.Nm mktemp
.Op Fl d
.Op Fl q
.Op Fl u
.Ar template
.Sh DESCRIPTION
The
.Nm mktemp
utility takes the given file name template and overwrites a
portion of it to create a file name.  This file name is unique
and suitable for use by the application.  The template may be
any file name with some number of
.Ql X Ns s
appended
to it, for example
.Pa /tmp/temp.XXXXXXXXXX .
The trailing
.Ql X Ns s
are replaced with the current process number and/or a
unique letter combination.
The number of unique file names
.Nm
can return depends on the number of
.Ql X Ns s
provided; six
.Ql X Ns s
will
result in
.Nm
testing roughly 26 ** 6 combinations.
.Pp
If
.Nm
can successfully generate a unique file name, the file
is created with mode 0600 (unless the
.Fl u
flag is given) and the filename is printed
to standard output.
.Pp
.Nm mktemp
is provided to allow shell scripts to safely use temporary files.
Traditionally, many shell scripts take the name of the program with
the PID as a suffix and use that as a temporary file name.  This
kind of naming scheme is predictable and the race condition it creates
is easy for an attacker to win.  A safer, though still inferior approach
is to make a temporary directory using the same naming scheme.  While
this does allow one to guarantee that a temporary file will not be
subverted, it still allows a simple denial of service attack.  For these
reasons it is suggested that
.Nm
be used instead.
.Sh OPTIONS
.Bl -tag -width indent
The available options are as follows:
.It Fl d
Make a directory instead of a file.
.It Fl q
Fail silently if an error occurs.  This is useful if
a script does not want error output to go to standard error.
.It Fl u
Operate in
.Dq unsafe
mode.  The temp file will be unlinked before
.Nm
exits.  This is slightly better than
.Fn mktemp 3
but still introduces a race condition.  Use of this
option is not encouraged.
.El
.Sh RETURN VALUES
The
.Nm
utility
exits with a value of 0 on success or 1 on failure.
.Sh EXAMPLES
The following
.Xr sh 1
fragment illustrates a simple use of
.Nm
where the script should quit if it cannot get a safe
temporary file.
.Bd -literal -offset indent
TMPFILE=`mktemp /tmp/$0.XXXXXXXXXX` || exit 1
echo "program output" >> $TMPFILE
.Ed
.Pp
In this case, we want the script to catch the error ourselves.
.Bd -literal -offset indent
TMPFILE=`mktemp -q /tmp/$0.XXXXXXXXXX`
if [ $? -ne 0 ]; then
	echo "$0: Can't create temp file, exiting..."
	exit 1
fi
.Ed
.Pp
Or perhaps you don't want to exit if
.Nm
is unable to create the file.  In this case you can protect the
part of the script thusly.
.Bd -literal -offset indent
TMPFILE=`mktemp /tmp/$0.XXXXXXXXXX` && {
	# Safe to use $TMPFILE in this block
	echo data > $TMPFILE
	...
	rm -f $TMPFILE
}
.Ed
.Sh SEE ALSO
.Xr mkdtemp 3 ,
.Xr mkstemp 3 ,
.Xr mktemp 3
.Sh HISTORY
The
.Nm
utility appeared in
.Ox 2.1 .